<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingDocman2 extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'docman2');
			$this->params = new JParameter($plugin->params);
		}
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
		if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'DOCman';
		$onePlugin->function = 'acymailingdocman2_show';
		$onePlugin->help = 'plugin-docman2';
		return $onePlugin;
	}

	function acymailingdocman2_show(){
		$config = acymailing_config();
		if($config->get('version') < '4.9.2'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$lang = JFactory::getLanguage();
		$lang->load('com_docman', JPATH_SITE);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.docman';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.docman_document_id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->titlelink = $app->getUserStateFromRequest($paramBase.".titlelink", 'titlelink', '|link', 'string');
		$pageInfo->cbaffiche = $app->getUserStateFromRequest($paramBase.".cbaffiche", 'cbaffiche', '|dispay', 'string');
		$pageInfo->download = $app->getUserStateFromRequest($paramBase.".download", 'download', '|download', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->clickable = $app->getUserStateFromRequest($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = $app->getUserStateFromRequest($paramBase.".clickableauto", 'clickableauto', '1', 'string');
		$pageInfo->contenttype = $app->getUserStateFromRequest($paramBase.".contenttype", 'contenttype', '|type:intro', 'string');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->autotitlelink = $app->getUserStateFromRequest($paramBase.".autotitlelink", 'autotitlelink', '|link', 'string');
		$pageInfo->autopict = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', '|filter:created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->contentorderdir = $app->getUserStateFromRequest($paramBase.".contentorderdir", 'contentorderdir', 'desc', 'word');
		$pageInfo->autocontenttype = $app->getUserStateFromRequest($paramBase.".autocontenttype", 'autocontenttype', '|type:intro', 'string');
		$pageInfo->downloadauto = $app->getUserStateFromRequest($paramBase.".download", 'download', '|download', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');

		$db = JFactory::getDBO();

		$searchFields = array('a.docman_document_id', 'a.title', 'b.title', 'c.username', 'a.storage_path');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.enabled = 1";
		}else{
			$filters[] = "a.enabled != -2";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.*,c.*,a.title doctitle FROM `#__docman_documents` AS a ';
		$query .= 'JOIN #__docman_categories AS b ON a.docman_category_id = b.docman_category_id ';

		$query .= 'LEFT JOIN `#__users` AS c ON a.created_by = c.id';
		if(!empty($pageInfo->filter_cat)) $filters[] = "a.docman_category_id = ".$pageInfo->filter_cat;

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = JRequest::getString('type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat' + catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat' + catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbaffiche.length; i++){
					if(document.adminForm.cbaffiche[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbaffiche[i].value;
						}else{
							otherinfo += ",";
							otherinfo += document.adminForm.cbaffiche[i].value;
						}
					}
				}
				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked){
						otherinfo += '| clickable:' + document.adminForm.clickable[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						otherinfo += '| pict:' + document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}
				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{docman:' + i + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbafficheauto.length; i++){
					if(document.adminForm.cbafficheauto[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbafficheauto[i].value;
						}else{
							otherinfo += ",";
							otherinfo += document.adminForm.cbafficheauto[i].value;
						}
					}
				}
				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked){
						otherinfo += '| clickable:' + document.adminForm.clickableauto[i].value;
					}
				}
				tmp = 0;
				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked){
						otherinfo += '|pict:' + document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				if(document.adminForm.max_article.value){
					otherinfo += "| max_article:" + document.adminForm.max_article.value;
				}
				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value + "," + document.adminForm.contentorderdir.value;
				}
				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){
					otherinfo += "| min_article:" + document.adminForm.min_article.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					otherinfo += document.adminForm.contentfilter.value;
				}
				<?php } ?>
				tag = '{autodocman:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';
				setTag(tag);
			}
			//-->
		</script>
		<?php
		$clickable = array();
		$clickable[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$clickable[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}
		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('docman_tab');
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), 'docman_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td><input type="checkbox" name="cbaffiche" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="describe" id="describe" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="describe" id="describe-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="caracteristics" id="caracteristics" onclick="updateTag();"/><label style="margin-left:5px" for="caracteristics" id="caracteristics-lbl"><?php echo JText::_('ACY_DETAILS');?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="icon" id="icon" onclick="updateTag();"/><label style="margin-left:5px" for="icon" id=""><?php echo JText::_('ACY_IMAGE');?></label></td>
			</tr>
			<tr>
				<td/>
				<td colspan="4"><input type="checkbox" name="cbaffiche" value="download" id="download" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="download" id="download-lbl"><?php echo JText::_('ACY_DOWNLOAD'); ?></label></td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td valign="top"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<!--====================================================================================LISTE DOCUMENTS===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th/>
				<th class="title">
					<?php
					echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
				<th class="title">
					<?php
					echo JHTML::_('grid.sort', JText::_('ACY_FILES'), 'a.storage_path', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php
					echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.docman_document_id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="5">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			for($i = 0, $a = count($rows); $i < $a; $i++){
				$row =& $rows[$i];
				?>
				<tr id="content<?php echo $row->docman_document_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->docman_document_id.",'row$k'"?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->doctitle;
						$text .= '<br /><b>'.JText::_('ACY_USERNAME', true).' : </b>'.$row->username;
						echo acymailing_tooltip($text, $row->description, '', $row->doctitle);
						?>
					</td>
					<td>
						<?php
						if(strpos($row->storage_path, ': ') != false){
							$arti = str_replace('/', '', strrchr(strip_tags($row->storage_path), '/'));
							echo $arti;
						}else{
							echo $row->storage_path;
						}
						?>
					</td>
					<td>
						<?php
						if(!empty($row->title)){
							$text = '<b>'.JText::_('TAG_CATEGORIES', true).' : </b>'.$row->title;
							echo acymailing_tooltip($text, $row->title, '', $row->title);
						}
						?>
					</td>
					<td align="center" style="text-align:center">
						<?php
						echo $row->docman_document_id;
						?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'docman_auto');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td><input type="checkbox" name="cbafficheauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td><input type="checkbox" name="cbafficheauto" value="describe" id="describeauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="describeauto" id="describeauto-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td><input type="checkbox" name="cbafficheauto" value="caracteristics" id="caracteristicsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="caracteristicsauto" id="caracteristicsauto-lbl"><?php echo JText::_('ACY_DETAILS');?></label></td>
				<td><input type="checkbox" name="cbafficheauto" value="icon" id="iconauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="iconauto" id="iconauto-lbl"><?php echo JText::_('ACY_IMAGE');?></label></td>
			</tr>
			<tr>
				<td/>
				<td colspan="4"><input type="checkbox" name="cbafficheauto" value="download" id="downloadauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="downloadauto" id="downloadauto-lbl"><?php echo JText::_('ACY_DOWNLOAD'); ?></label></td>
			</tr>
			<tr>
				<td valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td valign="top"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
			</tr>
			<tr>
				<td><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td colspan="4">
					<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', 1); ?>
				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('ACY_ORDER'); ?></td>
				<td colspan="2">
					<?php
					$values = array('id' => 'ACY_ID', 'publish_on' => 'CREATED_DATE', 'modified_on' => 'MODIFIED_DATE', 'docman_category_id' => 'ACY_CATEGORY', 'title' => 'FIELD_TITLE');
					echo $acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td>
					<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td>
						<?php echo JText::_('JOOMEXT_FILTER'); ?>
					</td>
					<td colspan="2">
						<?php $filter = acymailing_get('type.contentfilter');
						$filter->onclick = 'updateTagAuto();';
						echo $filter->display('contentfilter', $pageInfo->contentfilter); ?>
					</td>
					<td>
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
				</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k = 0;
			foreach($this->catvalues as $oneCat){
				if(empty($oneCat->value)) continue;
				?>
				<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo $oneCat->text;
						?>
					</td>
				</tr>
				<?php $k = 1 - $k;
			} ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT descendant_id id,ancestor_id parent_id,title '.'FROM #__docman_categories dc '.'INNER JOIN #__docman_category_relations dcr '.'ON dcr.descendant_id=dc.docman_category_id '.'WHERE (dcr.level=1 AND dcr.descendant_id<>dcr.ancestor_id) '.'ORDER BY `id` ASC');
		$mosetCats = $db->loadObjectList();

		$db2 = JFactory::getDBO();
		$db2->setQuery('SELECT descendant_id id,ancestor_id parent_id,title '.'FROM #__docman_categories dc '.'INNER JOIN #__docman_category_relations dcr '.'ON dcr.descendant_id=dc.docman_category_id '.'WHERE (SELECT count(dcr2.descendant_id) FROM #__docman_category_relations dcr2 WHERE dcr.descendant_id=dcr2.descendant_id)=1 '.'ORDER BY `id` ASC');
		$mosetCats2 = $db2->loadObjectList();
		$this->cats = array();
		$this->cats2 = array();
		foreach($mosetCats2 as $oneCat2){
			$this->cats2[] = $oneCat2;
		}
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	function _handleChildrens($parent_id = 0, $level = 0){
		if($parent_id == 0){
			foreach($this->cats2 as $cat2){
				$this->catvalues[] = JHTML::_('select.option', $cat2->id, str_repeat(" - - ", 0).$cat2->title);
				$this->_handleChildrens($cat2->id, $level + 1);
			}
		}else{
			if(!empty($this->cats[$parent_id])){
				foreach($this->cats[$parent_id] as $cat){
					$this->catvalues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->title);
					$this->_handleChildrens($cat->id, $level + 1);
				}
			}
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$match = '#{docman:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}
		//If we didn't find anything...
		if(!$found) return;
		$this->currentcat = '';
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//let's determine the Itemid
		$menuid = $this->params->get('itemid');
		if(empty($menuid)){
			$db = JFactory::getDBO();
			$db->setQuery('SELECT id FROM #__menu WHERE link LIKE "%index.php?option=com_docman&view=%list%" LIMIT 1');
			$menuid = $db->loadResult();
			if(empty($menuid)) acymailing_display('The itemId was not found, please create a DOCman menu or specify the itemId in the plugin\'s configuration.', 'warning');
		}

		if(!empty($menuid)){
			$this->itemId = '&Itemid='.$menuid;
		}else $this->itemId = '';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;
				$content = $this->_replaceContent($allresults, $i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content, true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$results, $i){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$arguments = explode('|', strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int)$arguments[0];
		for($i = 1, $a = count($arguments); $i < $a; $i++){
			$args = explode(':', $arguments[$i]);
			$arg0 = trim($args[0]);
			if(empty($arg0)) continue;
			if(isset($args[1])){
				$tag->$arg0 = $args[1];
			}else{
				$tag->$arg0 = true;
			}
		}
		if(!empty($tag->display)){
			$tmp = explode(',', strip_tags($tag->display));
			foreach($tmp as $onetmp){
				$tag->$onetmp = true;
			}
		}
		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT a.*, b.title AS cattitle, b.slug AS catslug, c.username '.'FROM #__docman_documents AS a '.'JOIN #__docman_categories AS b '.'ON a.docman_category_id = b.docman_category_id '.'LEFT JOIN `#__users` AS c '.'ON a.created_by = c.id '.'WHERE a.docman_document_id = '.intval($tag->id).' '.'LIMIT 1';
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();
		$result = '';
		//In case of we could not load the article for any reason...
		$app = JFactory::getApplication();
		if(empty($article)){
			if($app->isAdmin()) $app->enqueueMessage('The document "'.$tag->id.'" could not be loaded', 'notice');
			return $result;
		}

		$varFields = array();
		foreach($article as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		$itemid = empty($tag->itemid) ? $this->itemId : '&Itemid='.intval($tag->itemid);

		$link = 'index.php?option=com_docman&view=document&slug='.$article->slug.$itemid.'&category_slug='.$article->catslug;
		$linkdownload = 'index.php?option=com_docman&view=download&slug='.$article->slug.$itemid.'&category_slug='.$article->catslug;
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;
		$linkdownload = acymailing_frontendLink($linkdownload);
		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary
		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';
		$resultTitle = '';

		if(!empty($tag->cattitle) && $article->cattitle != $this->currentcat){
			$this->currentcat = $article->cattitle;
			$resultTitle .= '<h3 class="cattitle">'.$article->cattitle.'</h3>';
		}

		if(!empty($tag->title)){
			$resultTitle .= $styleTitle;
			if(!empty($tag->clickable)) $resultTitle .= '<a href="'.$link.'" target="_blank" >';
			$resultTitle .= $article->title;
			if(!empty($tag->clickable)) $resultTitle .= '</a>';
			$resultTitle .= $styleTitleEnd;
		}

		//We add the intro text
		if(!empty($tag->download)){
			$download = '<a style="text-decoration:none;" target="_blank" href="'.$linkdownload.'"><span class="acymailing_readmore">'.JText::_('ACY_DOWNLOAD').'</span></a>';
		}else{
			$download = '';
		}

		if(!empty($tag->icon) && !empty($article->image)){
			$img = '<img src="'.ACYMAILING_LIVE.'joomlatools-files/docman-images/'.$article->image.'" style="float:left;margin:5px;" />';
		}else{
			$img = '';
		}

		$varFields['{img}'] = $img;

		if(!empty($tag->describe)){
			$descrip = $article->description;
		}else{
			$descrip = '';
		}

		if(!empty($tag->caracteristics)){
			preg_match('/\.[^\.]+$/i', $article->storage_path, $ext);
			$result .= JText::_('FIELD_TYPE').' : '.$ext[0].'<br />';
			if(!empty($article->storage_path)){
				/*if(strpos($article->storage_path,': ')!= FALSE){
					$arti = str_replace('/','',strrchr($article->storage_path,'/'));
					$result .= JText::_('ACY_FILE').' : '.$arti.'<br />';
					$result .= JText::_('FIELD_SIZE').' : Link<br />';
				}else{*/
				$result .= JText::_('ACY_FILE').' : '.$article->storage_path.'<br />';
				$filename = ACYMAILING_ROOT.'joomlatools-files'.DS.'docman-files'.DS.$article->storage_path;
				if(JFile::exists($filename)){
					$fileSize = $this->_bytes2text(filesize($filename));
					$result .= JText::_('FIELD_SIZE').' : '.$fileSize.'<br />';
				}
				//}
			}
			if(!empty($article->username)){
				$result .= JText::_('ACY_AUTHOR').' : '.$article->username.'<br />';
			}
			if(!empty($article->publish_on)){
				$result .= JText::_('CREATED_DATE').' : '.$article->created_on.'<br />';
			}
			$result = $resultTitle.'<table border="0"><tr><td>'.$img.''.$descrip.'</td></tr><tr><td>'.$result.'</td></tr></table>'.$download;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$img.$descrip.$download;
		}
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'docman.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'docman.php');
			$result = ob_get_clean();
		}
		$result = $acypluginsHelper->removeJS($result);
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight', 150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth', 150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}
		return $result;
	}

	//function to convert bytes into smart display
	function _bytes2text($bytes){
		if($bytes > 1024){
			$ffileSize = $bytes / 1024;
			if($ffileSize > 1024){
				$ffileSize = $ffileSize / 1024;
				if($ffileSize > 1024){
					$ffileSize = $ffileSize / 1024;
					$ffileSize = (int)($ffileSize);
					$ffileSize .= " Gibabytes";
				}else{
					$ffileSize = (int)($ffileSize);
					$ffileSize .= " Megabytes";
				}
			}else{
				$ffileSize = (int)($ffileSize);
				$ffileSize .= " Kilobytes";
			}
		}else{
			$ffileSize = (int)($bytes);
			$ffileSize = $ffileSize." Bytes";
		}
		return $ffileSize;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag, strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result)), $email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$time = time();
		//Check if we find some tags
		$match = '#{autodocman:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}
		//If we didn't find anything... so we won't generate
		if(!$found) return $return;
		$this->tags = array();
		$db = JFactory::getDBO();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;
				//we search the caracteristics of the tag
				$arguments = explode('|', strip_tags($allresults[1][$i]));
				//The first argument is a list of cats
				$allcats = explode('-', $arguments[0]);
				$parameter = new stdClass();
				for($i = 1; $i < count($arguments); $i++){
					$args = explode(':', $arguments[$i]);
					$arg0 = trim($args[0]);
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//we load the documents according to the tag
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int)$oneCat;
				}
				$query = 'SELECT docman_document_id id FROM #__docman_documents';
				$where = array();
				if(!empty($selectedArea)){
					$where[] = '`docman_category_id` IN ('.implode(',', $selectedArea).')';
				}
				if(!empty($parameter->filter)){
					if($parameter->filter == 'modify'){
						$where[] = ' `modified_on` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
					}elseif($parameter->filter == 'created'){
						$where[] = ' `created_on` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
					}
				}
				$where[] = "enabled = 1";

				if(!empty($parameter->access)){
					$access = explode(',', $parameter->access);
					JArrayHelper::toInteger($access);
					$where[] = 'access IN ('.implode(',', $access).')';
				}

				$query .= ' WHERE ('.implode(') AND (', $where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',', $parameter->order);
					if($parameter->order == 'rand' || $ordering[0] == 'rand'){
						$query .= ' ORDER BY rand()';
					}else{
						$query .= ' ORDER BY `'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
					}
				}
				if(!empty($parameter->max_article)){
					$query .= ' LIMIT '.(int)$parameter->max_article;
				}elseif(empty($email->params['lastgenerateddate'])){
					$query .= ' LIMIT 20';
				}
				//We add a limit for the preview otherwise we could break everything
				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);
				if(!empty($parameter->min_article) && count($allArticles) < $parameter->min_article){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough Docman content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}
				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autodocman.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autodocman.php');
						$stringTag = ob_get_clean();
					}else{
						$arrayElements = array();
						foreach($allArticles as $oneArticleId){
							$args = array();
							$args[] = 'docman:'.$oneArticleId;
							if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
							if(!empty($parameter->clickable)) $args[] = 'clickable:'.$parameter->clickable;
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							if(!empty($parameter->cattitle)) $args[] = 'cattitle:1';
							if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
							$arrayElements[] = '{'.implode('|', $args).'}';
						}
						$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
					}
				}
				$this->tags[$oneTag] = $stringTag;
			}
		}
		return $return;
	}
}//endclass
?>